# Redakční systém


## Import do IntelliJ idea

Po stažení z gitu a následné indexaci by měl být projekt připraven.
Tento postup zajišťuje rozdělení modulů, které obsahují vlastní pom.xml soubor,
díky kterému Maven, dokáže oddělit jednotlivé moduly.

Mělo by se jednat o strukturu:
 - Backend (složka: backend-redakcnisystem)
 - Frontend (složka: frontend-redakcnisystem)
 - Ostatní
   - docker-compose.yml pro spuštění v rámci dockeru
   - readme-files složka pro soubory využité pro readme napříč projektem
   - pom.xml hlavní maven pom.xml

## Databáze
Pro fungování systému je potřebná databáze MySQL (testováno s verzí 8).
Název databáze je redakcnisystem. Ten však lze změnit, což je potřeba zohlednit v nastavení backendu.
Zároveň je potřeba případně změnit port, uživatele, heslo.
Viz [Backend readme](backend-redakcnisystem/README.md). 

## Spuštění

### Spuštění z IntelliJ idea

#### Backend
Vzhledem k využití mavenu, by mělo dojít k načtení konfigurace
pro spuštění backendu v IDE. Tento krok je případně popsán v 
[Backend readme](backend-redakcnisystem/README.md).

#### Frontend
Konfigurace pro spuštění frontendu není načtena automaticky,
její vytvoření je však velmi snadné, případná fotografie nastavení
je viditelná v [Frontend readme](frontend-redakcnisystem/README.md).

### Docker
Pro spuštění s využitím Dockeru, je připraven docker-compose
a jednotlivé Dockerfile v modulu frontendu a backendu.

Docker-compose je tvořen se snahou uložení dat do volumes.

### První spuštění

Při prvním spuštění neobsahuje systém žádná data. 
**První registrovaný uživatel, je automaticky nastaven jako správce.**

