package cz.uhk.fim.redakcnisystem.constants;

import cz.uhk.fim.redakcnisystem.response.ServiceError;
import cz.uhk.fim.redakcnisystem.response.ServiceResult;
import org.springframework.http.HttpStatus;

import java.util.Collections;

public class Errors {

    public static <T> ServiceResult<T> youMustLogIn() {
        return ServiceResult.createServiceResult(
                Collections.singletonList(
                        new ServiceError("you-must-log-in", "Nejprve se musíte přihlásit.")),
                HttpStatus.NOT_ACCEPTABLE);
    }

    public static <T> ServiceResult<T> userNotFound() {
        return ServiceResult.createServiceResult(
                Collections.singletonList(
                        new ServiceError("user-not-found", "Uživatel nebyl nalezen.")),
                HttpStatus.NOT_FOUND);
    }

    public static <T> ServiceResult<T> articleNotFound() {
        return ServiceResult.createServiceResult(
                Collections.singletonList(
                        new ServiceError("article-not-found", "Článek nebyl nalezen.")),
                HttpStatus.NOT_FOUND);
    }

    public static <T> ServiceResult<T> articleIsNotVisible() {
        return ServiceResult.createServiceResult(Collections.singletonList(
                        new ServiceError("article-is-not-visible", "Článek není dostupný.")),
                HttpStatus.FORBIDDEN);
    }

    public static <T> ServiceResult<T> articleHasNotSurvey(){
        return singletonError("article-has-not-survey", "Článek nemá anketu", HttpStatus.NOT_FOUND);
    }

    public static <T> ServiceResult<T> singletonError(String errorKey, String errorMessage, HttpStatus status){
        return ServiceResult.createServiceResult(Collections.singletonList(
                new ServiceError(errorKey, errorMessage)),
                status);
    }
}
