package cz.uhk.fim.redakcnisystem.contentmanagement.dtoOut;

import cz.uhk.fim.redakcnisystem.contentmanagement.records.Article;
import cz.uhk.fim.redakcnisystem.contentmanagement.records.RatingArticle;
import cz.uhk.fim.redakcnisystem.usermanagement.records.User;
import lombok.Data;

import java.time.ZonedDateTime;

@Data
public class AdminRatingFeedOut {

    private Integer userId;
    private String username;

    private Integer articleId;
    private String title;

    private Integer ratingUser;
    private ZonedDateTime createTime;

    public void setFromRating(RatingArticle ratingArticle){
        setUserData(ratingArticle.getUser());
        setArticleData(ratingArticle.getArticle());
        setRatingData(ratingArticle);
    }

    private void setUserData(User userData){
        this.userId = userData.getId();
        this.username = userData.getUsername();
    }

    private void setArticleData(Article articleData){
        this.articleId = articleData.getId();
        this.title = articleData.getTitle();
    }

    private void setRatingData(RatingArticle ratingData){
        this.ratingUser = ratingData.getRating();
        this.createTime = ratingData.getCreateTime();
    }
}
