package cz.uhk.fim.redakcnisystem.contentmanagement.dtoOut.statistics;

import cz.uhk.fim.redakcnisystem.contentmanagement.records.Article;
import lombok.Data;

import java.time.ZonedDateTime;
import java.util.ArrayList;
import java.util.List;

@Data
public class AdminArticleStatisticsOut {
    private Integer id;
    private String title;
    private ZonedDateTime createTime;
    private ZonedDateTime lastUpdateTime;
    private Float rating;
    private Integer countOfSaved;
    private Integer countOfAllComments;
    private Integer countOfAllRatings;
    private Integer[] sumOfEachRatingValue = new Integer[5];

    private List<AdminStatisticsPairOut> newArticleRatings = new ArrayList<>();
    private List<AdminStatisticsPairOut> allArticleRatings = new ArrayList<>();

    private List<AdminStatisticsPairOut> newArticleComments = new ArrayList<>();
    private List<AdminStatisticsPairOut> allArticleComments = new ArrayList<>();

    private List<AdminStatisticsPairOut> newArticleViews = new ArrayList<>();
    private List<AdminStatisticsPairOut> allArticleViews = new ArrayList<>();

    private AdminSurveyStatisticsOut survey = null;

    public void saveOtherInfoFromArticle(Article article){
        setId(article.getId());
        setTitle(article.getTitle());
        setCreateTime(article.getCreateTime());
        setLastUpdateTime(article.getLastUpdateTime());

        setCountOfSaved(article.getUsersSavedArticle().size());
        setCountOfAllComments(article.getComments().size());
        setCountOfAllRatings(article.getRatings().size());
    }

    public void saveValueForSumOfEachRatingByIndex(Integer value, int index){
        sumOfEachRatingValue[index] = value;
    }

    public void addNewArticleRatings(AdminStatisticsPairOut add){
        newArticleRatings.add(add);
    }
    public void addNewArticleComments(AdminStatisticsPairOut add){
        newArticleComments.add(add);
    }
    public void addNewArticleViews(AdminStatisticsPairOut add){
        newArticleViews.add(add);
    }
    public void addAllArticleRatings(AdminStatisticsPairOut add){
        allArticleRatings.add(add);
    }
    public void addAllArticleComments(AdminStatisticsPairOut add){
        allArticleComments.add(add);
    }
    public void addAllArticleViews(AdminStatisticsPairOut add){
        allArticleViews.add(add);
    }
}
