package cz.uhk.fim.redakcnisystem.contentmanagement.dtoOut.statistics;

import cz.uhk.fim.redakcnisystem.usermanagement.records.User;
import cz.uhk.fim.redakcnisystem.usermanagement.records.enums.UserGenderEn;
import cz.uhk.fim.redakcnisystem.usermanagement.records.enums.UserRoleEn;
import lombok.Data;

import java.time.ZonedDateTime;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Data
public class AdminUserStatisticsOut {

    private List<AdminStatisticsPairOut> uniqueLogins = new ArrayList<>();
    private List<AdminStatisticsPairOut> articleReads = new ArrayList<>();
    private List<AdminStatisticsPairOut> articleComments = new ArrayList<>();
    private List<AdminStatisticsPairOut> articleRatings = new ArrayList<>();

    private Integer countAllRatings;
    private Float averageOfAllRatings;
    private Integer countAllComments;

    private String email;
    private Date birthDate;
    private Integer age;
    private UserGenderEn gender;
    private String username;
    private ZonedDateTime registrationDateTime;
    private List<UserRoleEn> roles;
    private Integer countOfSavedArticles;

    public void addUniqueLogins(AdminStatisticsPairOut toAdd){
        uniqueLogins.add(toAdd);
    }

    public void addArticleReads(AdminStatisticsPairOut toAdd){
        articleReads.add(toAdd);
    }

    public void addArticleComments(AdminStatisticsPairOut toAdd){
        articleComments.add(toAdd);
    }

    public void addArticleRatings(AdminStatisticsPairOut toAdd){
        articleRatings.add(toAdd);
    }

    public void setOtherInfoFromUser(User user) {
        setEmail(user.getEmail());
        setBirthDate(user.getBirthDate());
        setGender(user.getGender());
        setUsername(user.getUsername());
        setRegistrationDateTime(user.getCreateTime());
        setRoles(new ArrayList<>());
        user.getRoles().forEach(userRole -> roles.add(userRole.getRole()));
        setCountOfSavedArticles(user.getSavedArticles().size());
    }
}
