package cz.uhk.fim.redakcnisystem.contentmanagement.records;

import lombok.Data;

import javax.persistence.*;
import java.util.List;

@Data
@Entity
public class ArticleSurvey {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(columnDefinition = "int unsigned")
    private Integer id;

    @OneToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "article_id", columnDefinition = "int unsigned")
    private Article article;

    private String surveyText;

    private Boolean surveyVisibleResults;

    @OneToMany(mappedBy = "articleSurvey", fetch = FetchType.LAZY, cascade = CascadeType.REMOVE)
    private List<ArticleSurveyOption> surveyOptions;

    @OneToMany(mappedBy = "articleSurvey", fetch = FetchType.LAZY, cascade = CascadeType.REMOVE)
    private List<ArticleSurveyVote> votes;
}
