package cz.uhk.fim.redakcnisystem.contentmanagement.records;

import cz.uhk.fim.redakcnisystem.usermanagement.records.User;
import lombok.Data;

import javax.persistence.*;
import java.time.ZonedDateTime;

@Data
@Entity
public class ArticleSurveyVote {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "user_id", columnDefinition = "int unsigned")
    private User user;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "article_survey_id", columnDefinition = "int unsigned")
    private ArticleSurvey articleSurvey;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "article_survey_option_id")
    private ArticleSurveyOption surveyOption;

    private ZonedDateTime createTime = ZonedDateTime.now();
}
