package cz.uhk.fim.redakcnisystem.contentmanagement.records;

import cz.uhk.fim.redakcnisystem.usermanagement.records.User;
import lombok.Data;

import javax.persistence.*;
import java.time.ZonedDateTime;

@Entity
@Data
public class ArticleViewActivity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /*
    * hashed IP from header, to prevent saving raw IP, but still recognize "request owner" to prevent refresh spam
     * */
    private String uniqueRecognitionId;

    @ManyToOne
    @JoinColumn(name = "user_id", columnDefinition = "int unsigned")
    private User user;

    private ZonedDateTime articleViewTime;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "article_id", columnDefinition = "int unsigned")
    private Article article;
}
