package cz.uhk.fim.redakcnisystem.contentmanagement.records;

import cz.uhk.fim.redakcnisystem.usermanagement.records.User;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.time.ZonedDateTime;

@Data
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name = "comment_article")
public class CommentArticle{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "article_id", columnDefinition = "int unsigned")
    private Article article;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "user_id", columnDefinition = "int unsigned")
    private User user;

    private String comment;
    private ZonedDateTime createTime = ZonedDateTime.now();

    private Boolean incorrect = false;
}
