package cz.uhk.fim.redakcnisystem.contentmanagement.repository;

import cz.uhk.fim.redakcnisystem.contentmanagement.dtoOut.ArticleAdminOut;
import cz.uhk.fim.redakcnisystem.contentmanagement.dtoOut.ArticlePreviewOut;
import cz.uhk.fim.redakcnisystem.contentmanagement.records.Article;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface ArticleRepository extends CrudRepository<Article, Integer> {
    List<Article> findAll(Sort create_time);

    @Query("SELECT new cz.uhk.fim.redakcnisystem.contentmanagement.dtoOut.ArticleAdminOut " +
            "(id, title, visibility, createTime, lastUpdateTime, 0) from Article")
    List<ArticleAdminOut> findAllArticleAdminOut();

    @Query("SELECT new cz.uhk.fim.redakcnisystem.contentmanagement.dtoOut.ArticlePreviewOut " +
            "(id, title, description, createTime, lastUpdateTime) from Article " +
            "WHERE title LIKE %:search%")
    List<ArticlePreviewOut> findAllArticlePreviewOutBySearch(@Param("search")String search);

    List<Article> findAllByTitleLikeOrTitleContains(String search, String search2);
}
