package cz.uhk.fim.redakcnisystem.contentmanagement.repository;

import cz.uhk.fim.redakcnisystem.contentmanagement.records.ArticleSurveyVote;
import org.springframework.data.repository.CrudRepository;

import java.time.ZonedDateTime;
import java.util.Optional;

public interface ArticleSurveyVoteRepository extends CrudRepository<ArticleSurveyVote, Long> {

    Optional<ArticleSurveyVote> findByArticleSurveyIdAndUserId(Integer articleSurvey_id, Integer user_id);

    Optional<Integer> countAllByCreateTimeBetweenAndArticleSurveyId(
            ZonedDateTime createTimeStart,
            ZonedDateTime createTimeEnd,
            Integer articleSurvey_id);

    Optional<Integer> countAllByArticleSurveyIdAndSurveyOptionId(Integer articleSurvey_id, Long surveyOption_id);
    Optional<Integer> countAllByArticleSurveyId(Integer articleSurvey_id);
}
