package cz.uhk.fim.redakcnisystem.contentmanagement.repository;

import cz.uhk.fim.redakcnisystem.contentmanagement.records.Article;
import cz.uhk.fim.redakcnisystem.contentmanagement.records.ArticleViewActivity;
import cz.uhk.fim.redakcnisystem.usermanagement.records.User;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import java.time.ZonedDateTime;
import java.util.List;
import java.util.Optional;

@Repository
public interface ArticleViewActivityRepository extends CrudRepository<ArticleViewActivity, Long> {

    Optional<ArticleViewActivity> findFirstByArticleAndUniqueRecognitionIdAndArticleViewTimeBetween(
            Article article,
            String uniqueRecognitionId,
            ZonedDateTime start,
            ZonedDateTime end);

    Optional<ArticleViewActivity> findFirstByArticleAndArticleViewTimeBetweenAndUser(
            Article article,
            ZonedDateTime start,
            ZonedDateTime end,
            User user);

    Integer countByArticleId(Integer articleId);

    List<ArticleViewActivity> findAllByArticleViewTimeBetween(ZonedDateTime articleViewTimeStart, ZonedDateTime articleViewTimeEnd);

    Optional<Integer> countAllByArticleViewTimeBetween(ZonedDateTime articleViewTimeStart, ZonedDateTime articleViewTimeEnd);

    Optional<Integer> countAllByArticleViewTimeBetweenAndUserId(ZonedDateTime articleViewTimeStart, ZonedDateTime articleViewTimeEnd, Integer user_id);

    Optional<Integer> countAllByArticleViewTimeBetweenAndArticleId(ZonedDateTime articleViewTimeStart, ZonedDateTime articleViewTimeEnd, Integer article_id);

    Optional<Integer> countAllByArticleViewTimeBeforeAndArticleId(ZonedDateTime articleViewTime, Integer article_id);

    List<ArticleViewActivity> findAllByUserId(Integer user_id);
}
