package cz.uhk.fim.redakcnisystem.contentmanagement.repository;

import cz.uhk.fim.redakcnisystem.contentmanagement.records.CommentArticle;
import org.springframework.data.repository.CrudRepository;

import java.time.ZonedDateTime;
import java.util.List;
import java.util.Optional;

public interface CommentArticleRepository extends CrudRepository<CommentArticle, Long> {
    List<CommentArticle> findCommentArticlesByArticleId(Integer articleId);
    List<CommentArticle> findAllByUserId(Integer userId);
    Integer countAllByUserId(Integer userId);

    List<CommentArticle> findAllByCreateTimeIsBetween(ZonedDateTime timeStart, ZonedDateTime timeEnd);

    Optional<Integer> countAllByCreateTimeBetween(ZonedDateTime createTimeStart, ZonedDateTime createTimeEnd);

    Optional<Integer> countAllByCreateTimeBetweenAndUserId(ZonedDateTime createTimeStart, ZonedDateTime createTimeEnd, Integer user_id);

    Optional<Integer> countAllByCreateTimeBetweenAndArticleId(ZonedDateTime createTimeStart, ZonedDateTime createTimeEnd, Integer article_id);

    Optional<Integer> countAllByCreateTimeBeforeAndArticleId(ZonedDateTime createTime, Integer article_id);
}
