package cz.uhk.fim.redakcnisystem.contentmanagement.service;

import cz.uhk.fim.redakcnisystem.contentmanagement.dtoOut.statistics.*;
import cz.uhk.fim.redakcnisystem.response.ServiceResult;

import java.time.ZonedDateTime;
import java.util.List;

public interface AdminStatisticsService {

    ServiceResult<List<AdminStatisticsPairOut>> getArticlesViewsBetweenDates(ZonedDateTime start, ZonedDateTime end);
    ServiceResult<List<AdminStatisticsPairOut>> getArticleCommentsBetweenDates(ZonedDateTime start, ZonedDateTime end);
    ServiceResult<List<AdminStatisticsPairOut>> getArticleRatingsBetweenDates(ZonedDateTime start, ZonedDateTime end);

    ServiceResult<List<AdminStatisticsPairOut>> getUniqueUsersLoginsBetweenDates(ZonedDateTime start, ZonedDateTime end);
    ServiceResult<List<AdminStatisticsPairOut>> getUsersLoginsBetweenDates(ZonedDateTime start, ZonedDateTime end);
    ServiceResult<List<AdminStatisticsPairOut>> getUsersRegistrationsBetweenDates(ZonedDateTime start, ZonedDateTime end);

    ServiceResult<AdminUserStatisticsOut> getSpecificUserStats(ZonedDateTime start, ZonedDateTime end, Integer userId);
    ServiceResult<List<AdminUserStatisticsSearchOut>> searchUsersOut(String usernameSearch);

    ServiceResult<List<AdminArticleStatisticsSearchOut>> searchArticlesOut(String articleSearch);

    ServiceResult<AdminArticleStatisticsOut> getSpecificArticleStats(ZonedDateTime start, ZonedDateTime end, Integer articleId);
}
