package cz.uhk.fim.redakcnisystem.contentmanagement.service;

import cz.uhk.fim.redakcnisystem.contentmanagement.dtoIn.ArticleIn;
import cz.uhk.fim.redakcnisystem.contentmanagement.dtoOut.ArticleAdminOut;
import cz.uhk.fim.redakcnisystem.contentmanagement.dtoOut.ArticleOut;
import cz.uhk.fim.redakcnisystem.contentmanagement.dtoOut.ArticlePreviewOut;
import cz.uhk.fim.redakcnisystem.response.ServiceResult;
import org.springframework.http.ResponseEntity;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;

public interface ArticleService {

    ServiceResult<ArticleOut> getArticle(Integer id, String userEmail, String remoteAddress);
    ServiceResult<List<ArticlePreviewOut>> getArticleList(Integer page);
    ServiceResult<List<ArticlePreviewOut>> getArticleSearch(String search);
    ServiceResult<String> addArticle(Integer userId, ArticleIn articleIn, MultipartFile image);
    ServiceResult<String> editArticle(Integer userId, Integer articleId, ArticleIn articleIn, MultipartFile image);

    ServiceResult<List<ArticleAdminOut>> getAdminArticleList(Integer userId);

    ServiceResult<String> changeVisibility(Integer userId, Integer articleId, Boolean visibility);

    ServiceResult<String> deleteArticle(Integer userId, Integer articleId);

    ResponseEntity<byte[]> getArticleImage(Integer id) throws IOException;
}
