package cz.uhk.fim.redakcnisystem.contentmanagement.service;

import cz.uhk.fim.redakcnisystem.contentmanagement.dtoOut.GalleryImageInfoOut;
import cz.uhk.fim.redakcnisystem.contentmanagement.records.json.AuthorPageData;
import cz.uhk.fim.redakcnisystem.contentmanagement.records.json.GeneralSettings;
import cz.uhk.fim.redakcnisystem.response.ServiceResult;
import org.springframework.http.ResponseEntity;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;

public interface SettingsService {

    ServiceResult<GeneralSettings> getGeneralSettings() throws IOException;
    ServiceResult<String> updateGeneralSettings(GeneralSettings generalSettings);

    ServiceResult<AuthorPageData> getAuthorPageData() throws IOException;
    ServiceResult<String> updateAuthorPageData(AuthorPageData authorPageData);

    byte[] getFavicon() throws IOException;
    ServiceResult<String> updateFavicon(byte[] icon) throws IOException;

    ServiceResult<String> uploadImages(MultipartFile[] files) throws IOException;

    ResponseEntity<byte[]> getImage(String imageName) throws IOException;

    ServiceResult<List<GalleryImageInfoOut>> getAllImagesNames();

    ServiceResult<String> deleteImage(String imageName);
}
