package cz.uhk.fim.redakcnisystem.contentmanagement.validation;

import cz.uhk.fim.redakcnisystem.contentmanagement.dtoIn.CommentArticleIn;
import cz.uhk.fim.redakcnisystem.response.ServiceError;

import java.util.List;

public class ArticleCommentValidation {

    //language=RegExp
    private static final String REG_EX_COMMENT = "^[A-ZÁ-Ža-zá-ž\\d ,.!-?+\\n]{1,490}$";

    public static void validateComment(List<ServiceError> errorList, CommentArticleIn commentArticleIn){
        if(commentArticleIn.getComment() == null || commentArticleIn.getComment().replaceAll("\\s", "").isEmpty()){
            errorList.add(new ServiceError("comment-is-empty", "Komentář je prázdný."));
        } else if(!commentArticleIn.getComment().matches(REG_EX_COMMENT)){
            errorList.add(new ServiceError("comment-is-not-valid", "Komentář obsahuje nedovolené znaky nebo je příliš dlouhý."));
        }
    }
}
