package cz.uhk.fim.redakcnisystem.contentmanagement.validation;

import cz.uhk.fim.redakcnisystem.contentmanagement.dtoIn.ArticleIn;
import cz.uhk.fim.redakcnisystem.response.ServiceError;

import java.util.List;

public class ArticleValidation {

    public static void validateArticleIn(List<ServiceError> errors, ArticleIn article){
        if(article.getTitle().isEmpty() || article.getTitle().isBlank())
            errors.add(new ServiceError("title-is-empty", "Titulek je prázdný."));
        if(article.getText().isEmpty() || article.getText().isBlank())
            errors.add(new ServiceError("text-is-empty", "Text je prázdný."));
        if(article.getDescription().isEmpty() || article.getDescription().isBlank())
            errors.add(new ServiceError("description-is-empty", "Popisek je prázdný."));

    }
}
