package cz.uhk.fim.redakcnisystem.response;


import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.http.ResponseEntity;

import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class ServerResponse<T> {
    private List<ServiceError> errors;
    private T body;

    public static <T> ResponseEntity<ServerResponse<T>> createResponseEntity(ServiceResult<T> serviceResult){
        return ResponseEntity.status(serviceResult.getHttpStatus())
                .body(createServerResponse(serviceResult));
    }
    public static <T> ServerResponse<T> createServerResponse(ServiceResult<T> serviceResult){
        return ServerResponse.<T>builder()
                .errors(serviceResult.getErrors())
                .body(serviceResult.getBody())
                .build();
    }
}
