package cz.uhk.fim.redakcnisystem.response;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import org.springframework.http.HttpStatus;

import java.util.ArrayList;
import java.util.List;

@Data
@AllArgsConstructor
@Builder
public class ServiceResult<T>{

    private List<ServiceError> errors;
    private T body;
    private HttpStatus httpStatus;

    public ServiceResult(){
        errors = new ArrayList<>();
    }

    public boolean addError(ServiceError serviceError) {
        return errors.add(serviceError);
    }

    public static <T> ServiceResult<T> createServiceResult(T body, HttpStatus httpStatus){
        return ServiceResult.<T>builder()
                .body(body)
                .httpStatus(httpStatus)
                .build();
    }

    public static <T> ServiceResult<T> createServiceResult(List<ServiceError> serviceErrors, HttpStatus httpStatus){
        return ServiceResult.<T>builder().errors(serviceErrors).httpStatus(httpStatus).build();
    }
}
