package cz.uhk.fim.redakcnisystem.usermanagement.records;

import cz.uhk.fim.redakcnisystem.usermanagement.records.enums.PrivacyTypeEn;
import lombok.Data;

import javax.persistence.*;

@Entity
@Data
public class UserPrivacySettings {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @OneToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "user_id", columnDefinition = "int unsigned", nullable = false)
    private User user;

    @Enumerated(EnumType.STRING)
    private PrivacyTypeEn emailPrivacy = PrivacyTypeEn.PRIVATE;

    @Enumerated(EnumType.STRING)
    private PrivacyTypeEn registrationTimePrivacy = PrivacyTypeEn.PUBLIC;

    @Enumerated(EnumType.STRING)
    private PrivacyTypeEn commentsPrivacy = PrivacyTypeEn.PUBLIC;

    @Enumerated(EnumType.STRING)
    private PrivacyTypeEn ratingsPrivacy = PrivacyTypeEn.PUBLIC;

    @Enumerated(EnumType.STRING)
    private PrivacyTypeEn bioPrivacy = PrivacyTypeEn.PUBLIC;

    @Enumerated(EnumType.STRING)
    private PrivacyTypeEn birthDatePrivacy = PrivacyTypeEn.PUBLIC;

    @Enumerated(EnumType.STRING)
    private PrivacyTypeEn genderPrivacy = PrivacyTypeEn.PUBLIC;

}
