package cz.uhk.fim.redakcnisystem.usermanagement.repository;

import cz.uhk.fim.redakcnisystem.usermanagement.records.User;
import cz.uhk.fim.redakcnisystem.usermanagement.records.UserLoginActivity;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;

import java.time.ZonedDateTime;
import java.util.Optional;

public interface UserLoginActivityRepository extends CrudRepository<UserLoginActivity, Long> {

    Optional<UserLoginActivity> findFirstByUserOrderByLoginTimeDesc(User user);
    Optional<Integer> countAllByLoginTimeBetween(ZonedDateTime loginTimeStart, ZonedDateTime loginTimeEnd);

    @Query(value = "select count(distinct ula.user) from UserLoginActivity ula where " +
            "ula.loginTime between :start AND :end")
    Optional<Integer> countUniqueUserBetweenTimes(@Param("start") ZonedDateTime start, @Param("end") ZonedDateTime end);

    Optional<Integer> countAllByLoginTimeBetweenAndUserId(ZonedDateTime loginTimeStart, ZonedDateTime loginTimeEnd, Integer userId);
}
