package cz.uhk.fim.redakcnisystem.usermanagement.repository;

import cz.uhk.fim.redakcnisystem.usermanagement.records.User;
import org.springframework.data.repository.CrudRepository;

import java.time.ZonedDateTime;
import java.util.List;
import java.util.Optional;


public interface UserRepository extends CrudRepository<User, Integer> {
    Optional<User> findByEmail(String email);
    Optional<User> findByUsername(String username);

    Optional<Integer> countAllByCreateTimeBetween(ZonedDateTime createTimeStart, ZonedDateTime createTimeEnd);

    List<User> findAllByUsernameLike(String username);
    List<User> findAllByUsernameContainsOrUsernameLike(String username, String username2);

}
