package cz.uhk.fim.redakcnisystem.usermanagement.service;

import cz.uhk.fim.redakcnisystem.response.ServiceResult;
import cz.uhk.fim.redakcnisystem.usermanagement.dtoIn.UserAdditionalInfoIn;
import cz.uhk.fim.redakcnisystem.usermanagement.dtoIn.UserDeletePasswordIn;
import cz.uhk.fim.redakcnisystem.usermanagement.dtoIn.UserPasswordChangeIn;
import cz.uhk.fim.redakcnisystem.usermanagement.dtoIn.UserPrivacySettingsIn;
import cz.uhk.fim.redakcnisystem.usermanagement.dtoOut.CurrentUserOut;
import cz.uhk.fim.redakcnisystem.usermanagement.dtoOut.UserAdminOut;
import cz.uhk.fim.redakcnisystem.usermanagement.dtoOut.UserOut;
import cz.uhk.fim.redakcnisystem.usermanagement.dtoOut.UserPrivacySettingsOut;
import cz.uhk.fim.redakcnisystem.usermanagement.records.UserImage;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;

public interface UserService {
    boolean userIsValid(Integer userID);
    ServiceResult<CurrentUserOut> currentUser(Integer userId);
    ServiceResult<UserOut> getUser(String userId, boolean isLogged, String loggedUsername);
    ServiceResult<String> editUserPassword(UserPasswordChangeIn userPasswordChangeIn, Integer userId);
    ServiceResult<String> postImageUser(MultipartFile image, Integer userId) throws IOException;
    ServiceResult<UserImage> getUserImage(String userId);

    Integer getUserId(String email);

    ServiceResult<List<UserAdminOut>> getUsersListAdmin();

    ServiceResult<UserPrivacySettingsOut> getUserPrivacySettings(Integer userId);
    ServiceResult<String> editUserPrivacySettings(Integer userId, UserPrivacySettingsIn privacySettingsIn);

    ServiceResult<String> deleteUser(Integer userId, UserDeletePasswordIn userDeletePasswordIn);

    ServiceResult<String> editUserAdditionalInformation(Integer userId, UserAdditionalInfoIn userAdditionalInfoIn);
}
