# Frontend

## Nastavení

Ve složce /src/components/... se je možné změnit některé nastavení.

AxiosConfig obsahuje nastavení výchozího configu, včetně hlavní částí URL adresy
pro dotazy na backend.

Constants zajišťuje překlad pohlaví a vytvoření cest pro odkazy na obrázky.

SettingsManager obsahuje výchozí nastavení pro formát datumu a názvu blogu. 
Toto nastavení je zároveň stejně nastaveno jako výchozí v rámci backendu, 
tudíž jeho změna zde, nebude zajišťovat trvalou změnu.

## Načtení do IntelliJ Idea
Pro snadné načtení modulu s frontend částí projektu, byl vytvoře pom.xml,
pro frontend. Celá struktura tedy využívá Maven pro udržení jednotné struktury projektu.

# Spuštění frontendu

## Samostatně
Pro spuštění samotného frontendu je nutné instalovat balíčky,
tudíž je potřebné provést příkaz npm install ve složce frontend-redakcnisystem.
Následně již stačí spustit samotná frontend, provedením příkazu npm start.

    npm install
    npm start 

## Docker
Pro spuštění skrze Docker, je vytvořen Dockerfile. 
Na spuštění celého systému je vhodné využít docker compose v hlavní složce.

## IntelliJ Idea
Zde je viditelné nastavení v rámci IDE IntelliJ Idea, pro spuštění frontendu. 
![img.png](../readme-files/run-frontend-idea.png)

# Použité knihovny

Knihovny je možné dohledat v package.json.
Hlavní knihovny jsou: React, Axios, React Bootstrap.
Níže je viditelný seznam ostatních knihoven včetně odkazů.

## Ostatní knihovny

Hodnocení hvězdičkami
https://www.npmjs.com/package/react-star-ratings

Editor https://github.com/zenoamaro/react-quill  
Modul pro fotky https://www.npmjs.com/package/quill-image-resize-module-react

Zobrazení textu z editoru (html parser) https://www.npmjs.com/package/html-react-parser

SEO https://www.npmjs.com/package/react-helmet

Galerie 

https://www.npmjs.com/package/yet-another-react-lightbox

https://react-photo-album.com/

<details>
<summary>
Default React README
</summary>

# Getting Started with Create React App

This project was bootstrapped with [Create React App](https://github.com/facebook/create-react-app).

## Available Scripts

In the project directory, you can run:

### `npm start`

Runs the app in the development mode.\
Open [http://localhost:3000](http://localhost:3000) to view it in your browser.

The page will reload when you make changes.\
You may also see any lint errors in the console.

### `npm test`

Launches the test runner in the interactive watch mode.\
See the section about [running tests](https://facebook.github.io/create-react-app/docs/running-tests) for more information.

### `npm run build`

Builds the app for production to the `build` folder.\
It correctly bundles React in production mode and optimizes the build for the best performance.

The build is minified and the filenames include the hashes.\
Your app is ready to be deployed!

See the section about [deployment](https://facebook.github.io/create-react-app/docs/deployment) for more information.

### `npm run eject`

**Note: this is a one-way operation. Once you `eject`, you can't go back!**

If you aren't satisfied with the build tool and configuration choices, you can `eject` at any time. This command will remove the single build dependency from your project.

Instead, it will copy all the configuration files and the transitive dependencies (webpack, Babel, ESLint, etc) right into your project so you have full control over them. All of the commands except `eject` will still work, but they will point to the copied scripts so you can tweak them. At this point you're on your own.

You don't have to ever use `eject`. The curated feature set is suitable for small and middle deployments, and you shouldn't feel obligated to use this feature. However we understand that this tool wouldn't be useful if you couldn't customize it when you are ready for it.

## Learn More

You can learn more in the [Create React App documentation](https://facebook.github.io/create-react-app/docs/getting-started).

To learn React, check out the [React documentation](https://reactjs.org/).

### Code Splitting

This section has moved here: [https://facebook.github.io/create-react-app/docs/code-splitting](https://facebook.github.io/create-react-app/docs/code-splitting)

### Analyzing the Bundle Size

This section has moved here: [https://facebook.github.io/create-react-app/docs/analyzing-the-bundle-size](https://facebook.github.io/create-react-app/docs/analyzing-the-bundle-size)

### Making a Progressive Web App

This section has moved here: [https://facebook.github.io/create-react-app/docs/making-a-progressive-web-app](https://facebook.github.io/create-react-app/docs/making-a-progressive-web-app)

### Advanced Configuration

This section has moved here: [https://facebook.github.io/create-react-app/docs/advanced-configuration](https://facebook.github.io/create-react-app/docs/advanced-configuration)

### Deployment

This section has moved here: [https://facebook.github.io/create-react-app/docs/deployment](https://facebook.github.io/create-react-app/docs/deployment)

### `npm run build` fails to minify

This section has moved here: [https://facebook.github.io/create-react-app/docs/troubleshooting#npm-run-build-fails-to-minify](https://facebook.github.io/create-react-app/docs/troubleshooting#npm-run-build-fails-to-minify)
</details>