const tokenStorageId = "jwt-token";
export const userIdCookieName = "userId";
const userRolesStorageId = "userRoles";
export const userCookiePathConf = {path: "/"};

const existsPattern = (key) => {
    return (localStorage.getItem(key) !== null
        && localStorage.getItem(key) !== "null"
        && localStorage.getItem(key) !== undefined)
}

export const getAuthToken = () => {
    return localStorage.getItem(tokenStorageId);
}

export const setAuthToken = (token) => {
    localStorage.setItem(tokenStorageId, token);
}

export const removeAuthToken = () => {
    localStorage.removeItem(tokenStorageId);
}

export const authTokenExists = () =>{
    return existsPattern(tokenStorageId);
}

export const setUserRoles = (roles) => {
    localStorage.setItem(userRolesStorageId, roles);
}

export const removeUserRoles = () => {
    localStorage.removeItem(userRolesStorageId);
}

export const getUserRoles = () => {
    return localStorage.getItem(userRolesStorageId).split(",");
}

export const userRolesExists = (role) => {
    if(role){
        return existsPattern(userRolesStorageId)
            ? localStorage.getItem(userRolesStorageId).includes(role)
            : false;
    } else {
        return existsPattern(userRolesStorageId);
    }
}
