import {getAuthToken} from "./AuthManager";

export const BASE_URL = "http://localhost:8080/api/v1";
const BEARER = "Bearer ";

export const AxiosDefaultConfig = {
    headers: {
        "Content-Type": "application/json",
        "Access-Control-Allow-Origin": "http://localhost:3000"
    },
    withCredentials: true,
}

export const AxiosConfig = () => {
    if (getAuthToken() === null || getAuthToken() === "null") {
        return (AxiosDefaultConfig)
    } else {
        let config = AxiosDefaultConfig;
        config.headers["Authorization"] = BEARER + getAuthToken();
        return (config);
    }
}

export const AxiosDefaultImageConfig = {
    headers: {
        "Content-Type": "multipart/form-data",
        "Access-Control-Allow-Origin": "http://localhost:3000",
    },
    withCredentials: true,
}

export const AxiosConfigImage = () => {
    if (getAuthToken() === null || getAuthToken() === "null") {
        return (AxiosDefaultImageConfig)
    } else {
        let config = AxiosDefaultImageConfig;
        config.headers["Authorization"] = BEARER + getAuthToken();
        return (config);
    }
}