import React from "react";
import {Helmet} from "react-helmet-async";

/**
 *
 * @param description {string} description for page
 * @param robots {string} text for robots
 * @constructor
 */
function SEOManager({description, robots}){

    return (
        <Helmet>
            <meta name="description" content={description}/>
            <meta name="robots" content={robots}/>
        </Helmet>
    )
}

export const SEO_ROBOTS = {
    INDEX_FOLLOW: "index, follow",
    NOINDEX_NOFOLLOW: "noindex, nofollow",
    INDEX_NOFOLLOW: "index, nofollow"
}
export default SEOManager;