import React, {useContext, useEffect, useState} from "react";
import {SettingsContext} from "../components/SettingsManager";

function Footer() {

    const [footerData, setFooterData] = useState({
        firstRow: "© "+ new Date().getFullYear() + " Copyright: ",
        secondRow: "Děkuji za návštěvu.",
        textColor: "#FAFAFA",
        backgroundColor: "#464646"
    });
    const settings = useContext(SettingsContext);

    useEffect(() => {
        if (settings)
            setFooterData({
                firstRow: settings.footerFirstRow,
                secondRow: settings.footerSecondRow,
                textColor: settings.footerTextColor,
                backgroundColor: settings.footerBackgroundColor
            });
    }, [settings]);

    return (
        <footer id={"footer"}
                style={{
                    color: footerData.textColor,
                    backgroundColor: footerData.backgroundColor
                }}
                className={"text-center"}>
            <div className={"p-1"}>
                {footerData.firstRow}
            </div>
            <div className={"text-center p-1"}>
                {footerData.secondRow}
            </div>
        </footer>
    );
}

export default Footer;