import React, {useState} from "react";
import "chart.js/auto";
import moment from "moment";
import ArticlesChart from "./ArticlesChart";
import {Col, Container, Row} from "react-bootstrap";
import UsersChart from "./UsersChart";
import CustomDateRangeSelect from "../../viewComponents/CustomDateRangeSelect";

function StatisticsPage() {

    const [actualDateRange, setActualDateRange] = useState({
        start: moment().subtract(7, "days"),
        end: moment()
    });
    return (
        <div id={"content"}>
            <Container>
                <Row className={"text-center"}>
                    <h1>Statistiky</h1>
                </Row>
                <Row>
                    <CustomDateRangeSelect onConfirmRange={(range) => setActualDateRange(range)}/>
                </Row>
                <br/>
                <Row className={"admin-stats-row"}>
                    <Col>
                        <Row className={"text-center"}>
                            <h3>Články</h3>
                        </Row>
                        <Row>
                            <ArticlesChart dateRange={actualDateRange}/>
                        </Row>
                    </Col>
                    <Col>
                        <Row className={"text-center"}>
                            <h3>Uživatelé</h3>
                        </Row>
                        <Row>
                            <UsersChart dateRange={actualDateRange}/>
                        </Row>
                    </Col>
                </Row>
            </Container>
        </div>
    )
}

export default StatisticsPage;